;===============================================================================
; I-nbi lugejaga "lukk". 
; felch@staff.ttu.ee
; 11.3.: ttab!
; Thja mlu puhul avab ukse (stab LED-i 1 sekundiks) iga nbiga. Seivimiseks hoia nupp vajutatuna ja nita npi. LED vilgub 2 korda. Nii saab seivida 2 vtit.
; Jrgmised vtmed seivitakse 2. kohale, 1. vti jb alati alles.
; Kui nidata vtme salvestamisel 1, vtit, kusutatakse mlemad. LED vilgub 4 korda.
; Vtme kood saadetakse seriali kiirusega 4800 bd. 
; Prose taktsagedus - 4MHz (sisemine generaator)
; Klaveri porti ei kasuta !
;===============================================================================

	LIST    p=12F629  	; Nimetame prose

	#include "P12F629.INC"  	
				errorlevel -302					; Compaileri vingumised ra
				errorlevel -305
				errorlevel -306 

 	__CONFIG _INTRC_OSC_NOCLKOUT & _PWRTE_ON & _BODEN_ON & _MCLRE_OFF & _WDT_OFF & _CP_OFF & _CPD_OFF   
;*********************** Raudvrk **********************************************
;*** vljundid ***
#define RS232_TX		GPIO,0					; seriali otc: 4800,n,8,1
#define Ibut			GPIO,1					; nbi sisend/vljund
#define	Tris_button		TRISIO,1
#define LED				GPIO,2					; kaardilugeja LEDi juhtimine, aktiivne = HIGH. Saab kasutada mingi luku magneti trimiseks
;*** sisendid ***
#define Nupp			GPIO,3					; kindralotstarbeline nupp, aktiivne = LOW
#define Clk				GPIO,5					; klaveri pordi takt, aktiivne = LOW
#define Dat				GPIO,4					; klaveri pordi daata, aktiivne = LOW
; ********************** constantsid *******************************************
#define	T1timeL				0xF0;0xFF				; 10 mS @ 4,0 MHz
#define	T1timeH				0xD8;0xC9				
#define CARRY           	STATUS,C 
#define ZERO            	STATUS,Z 
#define pank            	STATUS,RP0
#define E_key_1	        	d'0'				; "oma" vtme 1 koodi algus EEPROMis
#define E_keydefined1       d'8'				; "oma" vtme 1 kood EEPROMisse salvestet kui siin kirjas 1. Algselt mistagi 0.
#define E_keydefined2       d'9'				; "oma" vtme 2 kood EEPROMisse salvestet kui siin kirjas 1. Algselt mistagi 0.
#define E_key_2	        	d'10'				; "oma" vtme 2 koodi algus EEPROMis
; ************** Mlu jaotus **********	    	
				cblock 0x20						; kuni 0x7F
;***** I-nbi asjad ****
; jooksvalt loetava nbi daata-ala
					work0                       ; CRC (8 bits)
					work1                       ; Nbi unikaalne kood (48 bitti ehk 6 baiti)
					work2                       ; "
					work3                       ; "
					work4                       ; "
					work5                       ; "
					work6                       ; "
					work7                       ; Family Code (8 bitti)7E
					OneWireByte
					TEMP0
					TEMP1
					TEMP2
					rombit_idx
					bits
					ctr_1wire
					curr_discrep
					last_discrep
					t_count						; viited ja saatmise baitide loendi
;***** ssteem ****
					W_Temp
					S_Temp
					count		
					Flags				
;***** RS232 *****
					rsbitcount
					tmp							; ka nbi koodi salvestamisel
					tmp1						; ka nbi koodi salvestamisel
					rscount
              endc


				org H'2100' 					; EEPROM 
				de 00h							; vti 1 ei ole mratud
				de 00h							; vtme 1 kood algselt nullis
				de 00h							; 
				de 00h							; 
				de 00h							; 
				de 00h							; 
				de 00h							; 
				de 00h							; 
				de 00h							; 
				de 00h							; vti 2 ei ole mratud
; ************* Lipud ****************	    	
#define 		sobib		 Flags,0			; 1 kui vti sobib lukuauku
#define			Keyok		 Flags,1			; np loetud
#define			ButTimeOut	 Flags,2
#define 		return_value Flags,3		
; *****************************	    	

;===============================================================================
; *** ja hakkab pihta...
;===============================================================================
              org         0x000
              goto        main

;===============================================================================
; *** Katckestus ...
;===============================================================================
Interrupt:        
				org     0004h 
Push    		movwf   W_Temp           		; seivi kontekst         
				swapf   STATUS,W         
				movwf   S_Temp           		   
				bcf     pank
Disable_Int: 	bcf     INTCON,GIE       		; keela katckestused        
				btfsc   INTCON,GIE       		       
				goto    Disable_Int      		
         
				btfsc   PIR1,TMR1IF      		; Taimer1 (aeg npi ksitleda)?         
				goto    Timer1_Int        		
Pop     			
				swapf   S_Temp,W         
				movwf   STATUS           		; taasta kontekst
				swapf   W_Temp,F         
				swapf   W_Temp,W         		
				retfie                   		; vlja siit, jta intsid lubatux (GIE  !)
;===============================================================================
; *** Taimeri katckestus ...
;===============================================================================
Timer1_Int:    	bcf     pank		 
				bcf		T1CON,TMR1ON			; stop taimer 1
				bcf     PIR1,T1IF    			; katkestuse nue maha   
;				bsf		viga        			; vea lipp psti
				bsf		ButTimeOut		 
				goto	Pop
;===============================================================================
; ******* Hakkame pihta... *******
;===============================================================================
main:			call	init					; maja korda
				movlw	'I'						; teatame, et oleme elus
				call	senddata
				movlw	'-'
				call	senddata
				movlw	'B'
				call	senddata
				movlw	'u'
				call	senddata
				movlw	't'
				call	senddata
				movlw	't'
				call	senddata
				movlw	'o'
				call	senddata
				movlw	'n'
				call	senddata
				bsf		T1CON,TMR1ON			; ksitleb npi iga X ms tagant
main_1:			btfss	ButTimeOut				; kki on I-nbi usutlemise aeg kes?
				goto	main_1					; veel mitte...
				bcf		ButTimeOut			
				bcf		T1CON,TMR1ON			; katkestused keelata lugemise ajaks
				bcf		INTCON,GIE
		       	call    Ibut_init				; nbi reset
				call    Search_1Wire     		; otsi npi heinakuhjast ja loe kui saad
             	btfss   return_value	  		; np vastab ?
	            goto    main_2			     	; eip !
				btfsc	Keyok					; kas ootame et np ra vetaks ?
				goto	main_3					; jah, ei mrgi npi loetuks
				bsf		Keyok					; mrgi, et ootame nbi eemaldamist (et ei saadax pidevalt kui np jb pessa) 
				call	send_but				; saada daata minema
				btfss	Nupp					; nupp vajutet ?
				goto	main_8					; jah, seivi nbi kood
				movlw	E_keydefined1			; kas vtme 1 kood mratud ?
				call	Read_EEPROM
				btfsc	ZERO
				goto	main_4					; ei
				call	compare_1				; jah, vrdle sellega
				btfss	sobib					; ige vti ?
				goto	main_4					; ei
				bsf		LED
				call	delay_1s				; sobib, hoia LEDi (ehk lukku) 1 sekund sees
				bcf		LED						; uks kinni
				goto	main_3
main_4:			movlw	E_keydefined2			; kas vtme 2 kood mratud ?
				call	Read_EEPROM
				btfsc	ZERO
				goto	main_5					; ei, ilmselt uus prose. Tee uks lahti
				call	compare_2				; jah, vrdle sellega
				btfss	sobib					; ige vti ?
				goto	main_6					; ei
main_5:			bsf		LED
				call	delay_1s				; sobib, hoia LEDi (ehk lukku) 1 sekund sees
main_6:			bcf		LED						; uks kinni
				goto	main_3					; enam ei saada kedagi, ootame nbi ra vtmist

main_2:			bcf		Keyok					; ei vastanud, jrelikult veti ra vi ei olnudki. Lubame jlle lugemise
				goto	main_3a

main_3:			call	delay_1s				; pisike viide et nbi loksumine pesas ei genereeriks uut "vajutust"
main_3a:		bcf     PIR1,T1IF    			; kell kima!
				movlw	T1timeL					
				movwf	TMR1L
				movlw	T1timeH
				movwf	TMR1H
				bsf		T1CON,TMR1ON
				bsf		INTCON,GIE
				goto	main_1
main_8:			movlw	E_keydefined1			; salvestame, kas vtme 1 kood mratud ?
				call	Read_EEPROM
				btfss	ZERO
				goto	main_9					; jah, sinna kohta ei salvesta
				movlw	E_key_1					; seivime loetu vtmeks 1
				call	save_key
				movlw	.2						; tulguta vilesid 2*
				movwf	tmp1	
				goto	main_11
main_9:			call	compare_1				; kas nidati 1. vtit ?
				btfsc	sobib
				goto	main_10					; jah, kustutame vtmete koodid mlust
				movlw	E_key_2					; ei, seivime loetu vtmeks 2
				call	save_key
				movlw	.2						; tulguta vilesid 2*
				movwf	tmp1	
				goto	main_11
main_10:		call	clr_keys
				movlw	.4
				movwf	tmp1
main_11:		bsf		LED						; vilguta LEDi 4*
				call	delay_03s				
				bcf		LED						
				call	delay_03s				
				decfsz	tmp1
				goto	main_11
				goto	main_3a
;===============================================================================
;******** I-nbi stuff. Tmmatud netist ja sobitatud **************************
;===============================================================================
;===============================================================================
; Store_Bit vtab bitt A (bits.1) ja salvestab alasse work, offset rombit_idx
; bits.1 -> work0..work7(rombit_idx)
;===============================================================================
Store_Bit:    call      SetupFSR         		; converdi rombit_idx mlu aadressiks
              rrf       bits, W          		; loe bit.1 W-sse
              andlw     b'00000001'     		; lolle aadresse ei luba
              addwf     PCL, F           		; oli 0 vi 1 ?
              goto      ClrWorkBit       		; 0 -kustuta bit (clr bit)

SetWorkBit:   clrc
              rlf       TEMP2, W         		; arvuta biti positsioon
              addwf     PCL, F           		; tsta sobiv bitt psti
              bsf       INDF, 7
              return
              bsf       INDF, 6
              return
              bsf       INDF, 5
              return
              bsf       INDF, 4
              return
              bsf       INDF, 3
              return
              bsf       INDF, 2
              return
              bsf       INDF, 1
              return
              bsf       INDF, 0
              return

ClrWorkBit:   clrc
              rlf       TEMP2, W         
              addwf     PCL, F           		; nulli sobiv bitt
              bcf       INDF, 7
              return
              bcf       INDF, 6
              return
              bcf       INDF, 5
              return
              bcf       INDF, 4
              return
              bcf       INDF, 3
              return
              bcf       INDF, 2
              return
              bcf       INDF, 1
              return
              bcf       INDF, 0
              return
;===============================================================================
;GetWorkBit -- rk0..work7(rombit_idx) -> W
;===============================================================================
GetWorkBit:   call      SetupFSR         		; viita soovitud bitile
 ;             movlw     HIGH GetWorkBit
 ;             movwf     PCLATH
              clrc
              rlf       TEMP2, W         		; bit pos. * 2 -> W
              addwf     TEMP2, W         		; W = bit offset * 3 (0, 3, 6 ...)
              addwf     PCL, F           		; hpe arvutet aadressile
;Bit 0
              btfss     INDF, 7          		; kas on (1)
               retlw    d'0'             		; ei, anna 0 tagasi
              retlw     d'1'             		; jah, anna 0 tagasi
;Bit 1
              btfss     INDF, 6   
               retlw    d'0'      
              retlw     d'1'       
;Bit 2
              btfss     INDF, 5        
               retlw    d'0'       
              retlw     d'1'           
;Bit 3
              btfss     INDF, 4      
               retlw    d'0'           
              retlw     d'1'       
;Bit 4
              btfss     INDF, 3      
               retlw    d'0'            
              retlw     d'1'           
;Bit 5
              btfss     INDF, 2       
               retlw    d'0'             	
              retlw     d'1'             	
;Bit 6
              btfss     INDF, 1          	
               retlw    d'0'             
              retlw     d'1'            
;Bit 7
              btfss     INDF, 0     
               retlw    d'0'        
              retlw     d'1'           
;===============================================================================
;******* SetupFSR -- FSR viitab tala rombit_idx'iga mratud baidile *********
;*********** TEMP1(byte offset), and TEMP2(bit offset) *************************
;===============================================================================
SetupFSR:       decf    rombit_idx, W    		; indeks alates 0-st
                sublw   d'63'            		; rombit_idx'i prdarv: 0-63->63-0
                movwf   TEMP1            		; liida offset
                andlw   b'00000111'      		; byte offset maha, jb offset
	            movwf   TEMP2            		; seivi          
                bcf		CARRY            		; byte offset TEMP1's paremale "kljendada"
                rrf     TEMP1, F         		
                bcf		CARRY                    
                rrf     TEMP1, F
                bcf		CARRY
	            rrf     TEMP1, F
              	movlw   work0	            	; FSR viitab nbi tala algusesse
              	movwf   FSR
              	movf    TEMP1,W            		
              	addwf   FSR, F           		; FSR viitab nutud baidile talas
              	return
;===============================================================================
; ********************** nbi reset *******************************************
;===============================================================================
Ibut_init:	 	movlw	work0					; nulli nbi tala (18 baiti)
				movwf	FSR
				movlw	.18
				movwf	count
				clrw							
Ibut_init1:		movwf	INDF					
				incf	FSR,F
				decfsz	count
				goto	Ibut_init1
				clrf	last_discrep
				bcf		Keyok					; np veel lugemata
				return
;===============================================================================
; ******* otsi npi *******
;===============================================================================
Search_1Wire: bcf	    return_value     		; tagastuse lipp nulli
              goto      Do_reset         		; hakka otsima

Do_reset:     call      Reset_1wire				; nbile saabast
              clrf      rombit_idx       		; set rom bit index to 1
              incf      rombit_idx, F
              clrf      curr_discrep     		; info ttlemise marker 0-i
              movlw     0xF0            		; "Search Rom" ksk
              movwf     OneWireByte
              call      Sendbyte_1wire   		; saada ksk
Get_2bits             
              call      Readbit_1wire    		; loe bitt bussilt
              movwf     bits             		; seivi
              bcf		CARRY                  
              rlf       bits,F          		; nihuta bitt A vasakule
              call      Readbit_1wire    		; loe bitt B bussilt 
              iorwf     bits,F			        ; seivi

              movf      bits,W

lookup_1x:    addwf     PCL, F           		; dekodeeri loetud bitt
              goto      bits_00          		; collisioon !
              goto      bits_01          		; loeti 0
              goto      bits_10          		; loeti 1
              goto      bits_11          		; Home alone...

bits_00:      movf      rombit_idx,W			; collisioon !
              xorwf     last_discrep, W
              btfss     ZERO			       	; rombit_idx = last_discrep ?
              goto     	_chknxt          		; Ei, checki edasi
              movlw     b'10'            		; Jepp , oletame, et loeti 1
              movwf     bits
              call      Store_Bit        		; salvesta 1 talasse
              goto      ack_bus

_chknxt:      movf      last_discrep,W	    	; saa jooxev biti pos.
              subwf     rombit_idx, W    		; vrdle eelnevaga
              btfss     CARRY       			; irombit_idx > last_discrep
              goto     _chknx2          		; ei 
              movlw     b'01'            		; Jepp , oletame, et loeti 0
              movwf     bits
              call      Store_Bit
              movf      rombit_idx,W			; rombit_idx = Icurpos
              movwf     curr_discrep
              goto      ack_bus

_chknx2:
;rombits(rombit_idx) = 0 ?
              call      GetWorkBit       		; loe bitt@work(rombit_idx)
              movwf     TEMP0            		; seivi
              movf      TEMP0,w

lookup_2x:    addwf     PCL, F           		; 0 vi 1
              goto      _zero            		; oli 0
_one:                                     		; oli 1
              movlw     b'10'            		; oletame et luges 1
              movwf     bits
              goto      ack_bus
_zero:
              movlw     b'01'            		; oletame et luges 0
              movwf     bits
              movf      rombit_idx,W			; sea discrepancy marker viitama rombit_idx'le
              movwf     curr_discrep
              goto      ack_bus
              
bits_01:      goto      _storit					; saime 0-i
bits_10:                                  		; saime 1-e
_storit:      call      Store_Bit        		; seivi talasse @ rombit_idx offset

ack_bus:	  bcf		CARRY
              rrf       bits,W          		; bit A -> W
              call      Sendbit_1wire    		; saada liinile
              incf      rombit_idx, F    		; nekst
              movf      rombit_idx,W	        ; kas index > 64
              sublw     d'65'            		; (ehk = 65)
              btfss     ZERO
              goto      Get_2bits        		; ei, otsi edasi

              movf      curr_discrep,W			; set last discrepancy to descrepancy marker     
              movwf     last_discrep
              btfsc     ZERO   					; is last discrepancy = 0?  
              bsf	    return_value
              goto      Wrapup
              
bits_11:      clrf      last_discrep			; kik on parteikoosolekul...
              goto      Wrapup             
Wrapup:       return
;===============================================================================
; ******* I-nbi reset *******
;===============================================================================
Reset_1wire:	bcf 	Ibut	               	; nbi otc madalax
				movlw	0xAA					; oota 515 uS
				call	wait_x
	            bsf 	Ibut	                ; krgex
				movlw	0xAA					; oota 515 uS
				call	wait_x
              	return
;===============================================================================
; ******* saadab ksubaidi registrist OneWireByte I-nbile *******
;===============================================================================
Sendbyte_1wire:	movlw	0x08					; 8 bitti
              	movwf   TEMP0
_send_1w_lp:    clrf    TEMP1            		; thjenda tala
              	bcf     TEMP1,0			        ; mngib, et saadab 0
              	bcf		CARRY       
              	rrf     OneWireByte,F   		; saadetav bitt -> CARRY
              	btfsc   CARRY			        ; mida ikkagi saadame ?
               	bsf     TEMP1,0         		; nagu olex 1
              	movf    TEMP1,W		            
              	call    Sendbit_1wire    		; saada
              	decfsz  TEMP0,F         		; 8 bitti saadetud ?
               	goto     _send_1w_lp      		; vara veel
              	return
;===============================================================================
; ******* saadab ksubiti I-nbile *******
;===============================================================================
Sendbit_1wire:  movwf   TEMP1
              	bcf     Ibut	         		; np madalax
              	btfsc   TEMP1,0 
               	bsf     Ibut	        		; pulsi lpp kui bitt oli 1
				movlw	0x11					; (Tslot + Trec) - Tlow1 = 59uS
				call	wait_x
	            bsf     Ibut	        		; pulsi lpp kui bitt oli 0
              	nop    							; Trec
	            return
;===============================================================================
; ******* loeb vastusbaidi A/B I-nbist registrisse OneWireByte *******
;===============================================================================
Readbyte_1wire:	movlw   d'8'
               	movwf   TEMP0
_read_1w_lp:   	call    Readbit_1wire
               	movwf   TEMP1            		; seivi loetud bitt
               	bcf		CARRY                   ; oletab et oli 0
              	btfsc   TEMP1,0         		; ja tegelikult ?
               	bsf		CARRY                  	; oli 1
              	rrf     OneWireByte, F   		; nihuta talasse
	            decfsz  TEMP0,F		 	        ; 8 bitti OK ?
               	goto     _read_1w_lp      		; vara veel
              	movf    OneWireByte,W		    ; jah, tulemus W-sse
              	return                     
;===============================================================================
; ******* loeb vastusbiti I-nbist *******
;===============================================================================
Readbit_1wire:	bcf    	Ibut	         		; nbi taktipulss - madalax
				nop
	            bsf    	Ibut	         		; taktipulss - krgex
				bsf		pank					; llitame nbi otca sisendiks
				bsf		Tris_button
				bcf		pank
	            clrf    TEMP1            		; oletame, et tuleb 0
				movlw	0x03					; oota ca 13uS
				call	wait_x
 	            btfsc   Ibut	         		; mis tuli ?
                bsf     TEMP1,0			        ; peab olema 1
				movlw	0x0E					; oota 49uS
				call	wait_x
              	movf    TEMP1,W
				bsf		pank					; llitame nbi otca vljundiks
				bcf		Tris_button
				bcf		pank
	            return
;===============================================================================
; ******* RS232-e ja klaveri pordi rutiinid *******
;===============================================================================
; ***** Saada nbi number (work0...8)  *****  
;===============================================================================
send_but:		movlw	work0
				movwf	FSR
				movlw	.8						; saadame kik 8 baiti (k.a. family code ja chksum, tuleb keerukam)
				movwf	t_count
send_but1:		movf	INDF,W
				call	senddata				; saada COM-porti kiirusega 4800 bd (8,n,1)
;				call	send_kbd				; saada sama smbol klaviatuuri porti
				incf	FSR,F
				decfsz	t_count
				goto	send_but1
				return
;;===============================================================================
;; ***** KLAVER: Saada W PS/2 porti *****  
;;===============================================================================
;send_kbd: 		movwf   tmp         
;				movlw   08h         
;				movwf   rsbitcount     			; 8 Bitti         
;				bcf     RS232_TX        		;  Start Bit         
;				call    Wait_Bit  
;Send_RS232_Loop         
;				btfsc   tmp,0         
;				goto    RS232_TX_1         
;				goto    RS232_TX_0  
;
;RS232_TX_1:         
;				bsf     RS232_TX         
;				goto    RS232_Cont  
;RS232_TX_0:         
;				bcf     RS232_TX         
;				goto    RS232_Cont  
;RS232_Cont:         
;				call    Wait_Bit         
;				rrf     tmp,1         
;				decfsz  rsbitcount,1         
;				goto    Send_RS232_Loop          
;
;				bsf     RS232_TX         
;				call    Wait_Bit          
;				call    Wait_Bit          
;				call    Wait_Bit          
;				return 
;===============================================================================
; ***** RS232: Saada W porti GP1 *****  
;===============================================================================
senddata: 		movwf   tmp         
				movlw   08h         
				movwf   rsbitcount     			; 8 Bitti         
				bcf     RS232_TX        		;  Start Bit         
				call    Wait_Bit  
Send_RS232_Loop         
				btfsc   tmp,0         
				goto    RS232_TX_1         
				goto    RS232_TX_0  

RS232_TX_1:         
				bsf     RS232_TX         
				goto    RS232_Cont  
RS232_TX_0:         
				bcf     RS232_TX         
				goto    RS232_Cont  
RS232_Cont:         
				call    Wait_Bit         
				rrf     tmp,1         
				decfsz  rsbitcount,1         
				goto    Send_RS232_Loop          

				bsf     RS232_TX         
				call    Wait_Bit          
				call    Wait_Bit          
				call    Wait_Bit          
				return 
;===============================================================================
; ******* viited *******
;===============================================================================
delay_03s:		movlw	.4						; 4 korda T0 letitumist
				movwf	tmp
				goto	del1s1
delay_1s:		movlw	.15						; 15 korda T0 letitumist
				movwf	tmp
del1s1:			movlw	0x00
				movwf	TMR0
				bcf		INTCON,T0IF
del1s2:			btfss	INTCON,T0IF
				goto	del1s2
				decfsz	tmp
				goto	del1s1
				return
; ***** 20 usec *****  
wait:			movlw	0xFF
wait_x:			movwf   t_count 
				goto	W60u_Loop
W60u_Loop         
				decfsz  t_count,F          
				goto W60u_Loop              
				return  
; ***** biti kestuse Wiide *****  
Dly:			movlw	0FFh
				movwf	rsbitcount
dly1:			call	Wait_Bit
				decfsz	rsbitcount,1
				goto	dly1
				return
Wait_Bit: 		movlw   .65         
				movwf   rscount 
W196u_Loop:     decfsz  rscount,1         
				goto 	W196u_Loop       
				return  
;===============================================================================
;***************** vrdleb vtme koodi salvestatuga ****************************
;===============================================================================
compare_1:		movlw	E_key_1
				goto	compare_3
compare_2:		movlw	E_key_2
compare_3:		movwf	tmp						; EEPROMi viit
				movlw	work0					; vtme daata viit
				movwf	FSR
				movlw	.8						; vtmes 8 baiti
				movwf	tmp1
				bcf		sobib					; esialgu oletame, et vti ei sobi
compare_4:		movf	tmp,W					; EEPROMi aadress
				call	Read_EEPROM				; loe EEPROMist
				subwf	INDF,W					; vrdsed ?
				btfss	ZERO
				return							; ei klapi, minema siit
				incf	FSR,F					; jrgmine nbi bait
				incf	tmp,F					; EEPROMis samuti
				decfsz	tmp1					; kik ?
				goto	compare_4				; tee aga tee...
				bsf		sobib					; nhh, ige vti ju !
				return  	
;===============================================================================
;************* Loeb EEPROMist baidi, aadress W-s, tulemus lheb W-sse **********
;===============================================================================
Read_EEPROM:	bsf     pank
				movwf	EEADR					; aadress EEPROMi registrisse
				bsf		EECON1,RD			 	; luba lugemine
				movf	EEDATA,W				; loe!
				bcf     pank
				return  
;===============================================================================
;**************** Kustutab EEPROMist mlemate vtmete koodid *******************
;===============================================================================
clr_keys:		movlw	work0					
				movwf	FSR
				clrw		
				movwf	INDF					; kirjutab nulle
				movwf	tmp						; EEPROMI aadressi viit=0
				movlw	.18						; kokku 18 baiti vaja killida
				movwf	tmp1
clr_keys_1:		movf	tmp,W					; EEPROMi aadress
				call	Write_EEPROM			; kirjuta ra
				incf	tmp,F					; jrgmine EEPROMi aadress
				decfsz	tmp1					; kik ?
				goto	clr_keys_1				; tee aga tee...
				return  
;===============================================================================
;***** seivib loetud vtme koodi alast work... EEPROMi, aadressi pointer W-s ***
;===============================================================================
save_key:		bcf		INTCON,GIE				; katkestused ei tohi segada
				movwf	tmp						; EEPROMi viit
				movlw	work0					; vtme daata viit
				movwf	FSR
				movlw	.8						; vtmes 8 baiti
				movwf	tmp1
save_key_1:		movf	tmp,W					; EEPROMi aadress
				call	Write_EEPROM			; kirjuta ra
				incf	FSR,F					; jrgmine nbi bait
				incf	tmp,F					; EEPROMis samuti
				decfsz	tmp1					; kik ?
				goto	save_key_1				; tee aga tee...
				movlw	.1						; mrgime et vti salvestatud
				movwf	INDF
				movf	tmp,W
				call	Write_EEPROM			; kirjuta ra			
				bsf		INTCON,GIE				; luba jlle katkestused
				return  

Write_EEPROM:	bsf     pank 
				movwf	EEADR
				movf	INDF,W			 		; nbi bait
				movwf	EEDATA					; EEPROMi registrisse
				bsf		EECON1,WREN				; lubame kirjutamise
				movlw	55h						; spets kood kirjutamise lubamiseks
				movwf	EECON2
				movlw	0AAh
				movwf	EECON2
				bsf		EECON1,WR					
save_key_2:		btfsc	EECON1,WR 				; ootame kirjutamise lppu
				goto	save_key_2
				bcf		EECON1,WREN				; keela kirjutamine
				bcf     pank 
				return
;===============================================================================
; ******* initsialiseerimine *******
;===============================================================================
init:
; **** kalibreeri sisemine gener ****
				bsf     pank      		 
				call 	3FFh 					
				movwf 	OSCCAL 					; Kalibreeri sisemine taktigene
				bcf     pank      		 
				clrf	TMR1L
				clrf	TMR1H
;-------------------------------				; taimerid
				bcf     INTCON,T0IE     		; keela Timer0 Interruptsid
				bcf     INTCON,T0IF            
				bcf		T1CON,TMR1ON			; stop taimer 1
				bsf     pank
 				bcf     PIE1,T1IE 	    		; keela Timer1 Interruptsid
				bcf     pank
				bcf     PIR1,T1IF    		
				movlw	T1timeL					; lae T1
				movwf	TMR1L
				movlw	T1timeH
				movwf	TMR1H
;-------------------------------				konf
				bsf     pank
				movlw   b'00000111'         
				movwf   OPTION_REG      		; 1:256, prescaler T0-le, sisemine takt, WPU lubatud 
;-------------------------------				pordid
				bcf     pank
				clrf	GPIO					; pordid nulli
				movlw 	07h 					; analoog komparaator vlja
				movwf 	CMCON 
				bsf     pank
				movlw	0x38					; RS_232, np ja LED vljundid, muud sisendid
				movwf 	TRISIO 
				movlw	0x38					; WPU-d
				movwf	WPU
				movlw	0x00					; int on change ei pruugi hetkel
				movwf	IOCB
				bcf     pank
				movlw	0x3B					; port sellisesse lhteseisu
				movwf 	GPIO 
;------------------------------- 				katkestused 
				bsf		INTCON,PEIE				; luba peripheral ints
				bcf		INTCON,T0IE				; T0 katkestusi ei luba
				movf	GPIO,W					; loe porti et port change int'i ei tekiks
				bcf		INTCON,GPIF				; port change katkestuse lipp maha
				bcf		INTCON,GPIE				; port on change int keelata
;------------------------------- 				Timer 1
				movlw	b'00000100'				; 1/1 prescaler, int osc, seisma
				movwf	T1CON
				bcf		PIR1,TMR1IF				; letit. lipp
				bsf     pank
				bsf		PIE1,TMR1IE				; luba T1 int
				bcf     pank
; **** lubame intsid ****
				bsf     INTCON,GIE        		; luba katkestused
    			return  
;-------------------------------			
				org		03FFh
				retlw	b'10010100'				; dummy OSCCAL
	end			
;******************************************************************************
